function createTiffGW(filename, image, headerGW, pathtofile)

oldfolder=cd(pathtofile);

%Create Tiff object in write mode
t = Tiff(filename,'w');

imgdata=image;

%Set the required Tiff information tags
tagstruct2.ImageLength = size(imgdata,1);
tagstruct2.ImageWidth = size(imgdata,2);
tagstruct2.Photometric = 1;
tagstruct2.BitsPerSample = 16;
tagstruct2.SampleFormat = 1; %This value is 1 for unsigned and 2 for signed
tagstruct2.SamplesPerPixel = 1; %Gray or color
tagstruct2.RowsPerStrip = 16; %Not sure how important that is
tagstruct2.PlanarConfiguration = Tiff.PlanarConfiguration.Chunky; %Not sure either
tagstruct2.Software = 'MATLAB';

%This is where I store my own information. The function metadataGW takes
%care of assembling all the information in one long string with a chosen
%structure.
if ~isempty(headerGW)
    tagstruct2.ImageDescription = metadataGW(headerGW, filename);
end

count=0;
for i=1:size(imgdata,3)
    %To save space my information is only stored in the first plane of each
    if count==1 && isfield(tagstruct2, 'ImageDescription')
        tagstruct2 = rmfield(tagstruct2,'ImageDescription');
    end
    %A new directory has to be written for each plane
    if count>0
        t.writeDirectory();
    end
    %This sets the tags for the current directory
    t.setTag(tagstruct2)
    %Writes the actual plane
    t.write(imgdata(:,:,i));
    count=count+1;
end

t.close();

cd(oldfolder);
end