function [kvpairs] = extract_kvpairs_from_tiff(tiff_file)
% This function extracts metadata from a tiff saved by createtiffGW as 
% key-value pairs within the ImageDescription field and will not
% necessarily work on generic tiffs.
% 

   kvpair_delimiter = ';';
   
   tiff_info  = imfinfo(tiff_file);
   
   GWmeta = tiff_info(1).ImageDescription;
   
   kvpair_ending_locations = regexp(GWmeta, kvpair_delimiter);
   
   num_kvpairs = length(kvpair_ending_locations)+1;
   
   % convert string into cell array of key-value pairs
   for k = 1:num_kvpairs
       
       if k==1
           starting_location = 1;
       else
           starting_location = 1+kvpair_ending_locations(k-1);
       end
       
       if k==num_kvpairs
           ending_location = length(GWmeta);
       else
           ending_location = kvpair_ending_locations(k);
       end
       
       kvpairs{k} = GWmeta(starting_location:ending_location);
              
   end
   

return;
