function varargout = downthetubeUI(varargin)
% DOWNTHETUBEUI MATLAB code for downthetubeUI.fig
%      DOWNTHETUBEUI, by itself, creates a new DOWNTHETUBEUI or raises the existing
%      singleton*.
%
%      H = DOWNTHETUBEUI returns the handle to a new DOWNTHETUBEUI or the handle to
%      the existing singleton*.
%
%      DOWNTHETUBEUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DOWNTHETUBEUI.M with the given input arguments.
%
%      DOWNTHETUBEUI('Property','Value',...) creates a new DOWNTHETUBEUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before downthetubeUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to downthetubeUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help downthetubeUI

% Last Modified by GUIDE v2.5 29-Jun-2018 18:06:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @downthetubeUI_OpeningFcn, ...
                   'gui_OutputFcn',  @downthetubeUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before downthetubeUI is made visible.
function downthetubeUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to downthetubeUI (see VARARGIN)

% Choose default command line output for downthetubeUI
handles.output = hObject;

if ~isempty(varargin) && ~isfield(handles, 'stack')
    nucl = varargin{1};
else
    return
end

    set(hObject, 'Name', nucl.Filename);

    scanaxis = nucl.ScanAxis;
%     scales = nucl.ScalesXYZ;

    origstack   = nucl.OrigStack;
    scaledstack = scale_stack(nucl.OrigStack, 'uint8');
    segstack = scale_stack(nucl.SegStack, 'uint8');
    objstack = scale_stack(nucl.ObjIdStack, 'uint8');

    origstack   = rot_scanaxis(origstack, [], scanaxis, 'scan');
    scaledstack = rot_scanaxis(scaledstack, [], scanaxis, 'scan');
    segstack = rot_scanaxis(segstack, [], scanaxis, 'scan');
    objstack = rot_scanaxis(objstack, [], scanaxis, 'scan');

    stack = scaledstack;
    
    N = size(stack,3);
    
    halfN = round(N/2);
    

    
    set(handles.slider_Stackpos, 'Min', 1);
    set(handles.slider_Stackpos, 'Max', N);
    set(handles.slider_Stackpos, 'Value', halfN);
    set(handles.slider_Stackpos, 'SliderStep', [1/N 10/N]);

    set(handles.text_N, 'String', num2str(N));
    set(handles.text_currentSliceNumber, 'String', num2str(halfN));
    
    h = figure;
    drawnow;

    handles.nucl = nucl;
    handles.stackfig = h;
    handles.stack = stack;
    handles.OrigStack = origstack;
    handles.ScaledStack = scaledstack;
    handles.SegStack = segstack;
    handles.ObjIdStack = objstack;

    % Update handles structure
    guidata(hObject, handles);

    update_plot(handles);
    
% UIWAIT makes downthetubeUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);
% get(handles.radio_StackOrig)

% --- Outputs from this function are returned to the command line.
function varargout = downthetubeUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure

varargout{1} = handles.output;


% --- Executes on button press in checkbox_nucl_ID.
function checkbox_nucl_ID_Callback(hObject, eventdata, handles) %#ok<*INUSD,*DEFNU>
% hObject    handle to checkbox_nucl_ID (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_nucl_ID
    update_plot(handles);

% --- Executes on button press in pushbutton_close.
function pushbutton_close_Callback(hObject, eventdata, handles) %#ok<*INUSL>
% hObject    handle to pushbutton_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    close(handles.stackfig);
    close(downthetubeUI);



% --- Executes on button press in checkbox_contour.
function checkbox_contour_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_contour (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_contour





% --- Executes on slider movement.
function slider_Stackpos_Callback(hObject, eventdata, handles)
% hObject    handle to slider_Stackpos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
    val = round(get(hObject, 'Value'));
    set(hObject,'Value',val);
    set(handles.text_currentSliceNumber, 'String', num2str(val));
    update_plot(handles);

% --- Executes during object creation, after setting all properties.
function slider_Stackpos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_Stackpos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in radio_OrigStack.
function radio_OrigStack_Callback(hObject, eventdata, handles)
% hObject    handle to radio_OrigStack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    % Hint: get(hObject,'Value') returns toggle state of radio_OrigStack
    if get(hObject, 'Value')
        handles.stack = handles.OrigStack;
        guidata(hObject, handles);
    end
    
    update_plot(handles);

% --- Executes on button press in radio_ScaledStack.
function radio_ScaledStack_Callback(hObject, eventdata, handles)
% hObject    handle to radio_ScaledStack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_ScaledStack
    if get(hObject, 'Value')
        handles.stack = handles.ScaledStack;
        guidata(hObject, handles);
    end
    
    update_plot(handles);

% --- Executes on button press in radio_SegStack.
function radio_SegStack_Callback(hObject, eventdata, handles)
% hObject    handle to radio_SegStack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_SegStack
    if get(hObject, 'Value')
        handles.stack = handles.SegStack;
        guidata(hObject, handles);
    end
    
    update_plot(handles);
    
% --- Executes on button press in radio_ObjIdStack.
function radio_ObjIdStack_Callback(hObject, eventdata, handles)
% hObject    handle to radio_ObjIdStack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_ObjIdStack
    if get(hObject, 'Value')
        handles.stack = handles.ObjIdStack;
        guidata(hObject, handles);
    end
    
    update_plot(handles);

    
function update_plot(handles)

    sliderval = round(get(handles.slider_Stackpos, 'Value'));
    
    figure(handles.stackfig);
    image(handles.stack(:,:,sliderval));
    colormap(gray(256));
    
    if get(handles.checkbox_nucl_ID, 'Value')        
        % future code for adding trackerID labels to plot
    end
    
    drawnow;
