function h = plot_pitch(nucleoid)
% PLOT_PITCH plots the pitch function for nucleoid datasets
%
% h = plot_pitch(nucleoid)
%
% nucleoid: structure outputted by nucleoid_centroid
% h: handle to plotted figure
%
cents = nucleoid.Cents;
xyzscales = nucleoid.ScalesXYZ;
% XXX TODO: Need ScalesTRZ, computed from ScalesXYZ

[xs, ys, zs] = deal(xyzscales(1), xyzscales(2), xyzscales(3));

ObjIDs = unique(cents.ObjID);

h = figure;
hold on;
for k = 1:length(ObjIDs)    
    idx = (cents.ObjID == ObjIDs(k));
    [zcyl,pitch,hand] = deal(cents.Zcyl(idx), cents.Pitch(idx), cents.Handed(idx));

    
    figure(h);
    plot(zcyl .* zs, pitch .* zs, 'k-');
    plot(zcyl(hand<0) .* zs, pitch(hand<0) .* zs, 'r.');  % XXX TODO: CONFIRM PITCH UNITS USE THE ZSCALING FACTOR
    plot(zcyl(hand>0) .* zs, pitch(hand>0) .* zs, 'b.');
end
    
xlabel('z');
ylabel('inst. pitch');

