function save_for_pymol(nucleoid, myfilename)

cents = nucleoid.Cents;

writetable(cents,strcat(myfilename,'.xlsx')); % 0525-2019 added to save Radius and Pitch parameters.

fid = fopen(myfilename, 'w');

% g = findgroups(cents.ObjID);
objlist = unique(cents.ObjID);

colorlist = {'tv_red', 'tv_blue', 'tv_green', 'tv_yellow'};
letters = 'abcdefghijklmnopqrstuvwxyz';
atomlabellist = '';

for k = 1:length(objlist)
    ObjTable = cents( cents.ObjID == objlist(k), : );
    for m = 1:height(ObjTable)
        if ObjTable.Handed(m) >= 0
            atomcolor = 'tv_blue';
        else
            atomcolor = 'tv_red';
        end
        
        atomlabel = [letters(k) num2str(m, '%03i')];
        linestring = ['pseudoatom ', atomlabel, ...
                      ', color = ' atomcolor, ...
                      ', pos = [', num2str(ObjTable.X(m)), ...
                      ', ', num2str(ObjTable.Y(m)), ...
                      ', ', num2str(ObjTable.Z(m)), ...
                      ']'];
         atomlabellist = [atomlabellist ' ' atomlabel];
         fprintf(fid, '%s \n', linestring);
      end
end

fprintf(fid, ['show spheres,' atomlabellist]);
% for k = 1:length(objlist)
%     fprintf(fid, '%s ', atomlabel{k});
% end
fprintf(fid, '\n');

fclose(fid);

% pseudoatom aa, color = tv_red, pos = [1, 1, -1] 
% pseudoatom bb, color = tv_blue, pos = [10, 1, -1]
% pseudoatom cc, color = tv_green, pos = [-1, 10, 5]
% pseudoatom jj, color =  tv_yellow, pos = [10, 10,-5] 

% show spheres, aa bb cc jj    % draws the points as spheres


return