function outs = thresholded_stack(stack, threshold, stackthreshyn)

stack = double(stack);

% Establish range of pixel values that the threshold should apply to
Px_min = min(stack(:));
Px_max = max(stack(:));

stack = (stack-Px_min) / (Px_max-Px_min);

if nargin < 2 || isempty(threshold)
    threshold = median(stack(:));
end

threshold = 0.52;

Y = size(stack,2);
Z = size(stack,3);

h = figure;

for y = 1:Y

    im = squeeze(stack(:,y,:));
    
    [level EM(y)] = graythresh(im);
    mask = im2bw(im, level);
    mask = bwareaopen(mask, 2);
    imagesc(mask); colormap(gray(65535));
    pause(.2);
    drawnow;
%     dil_mask = mask;
%     dilation_step_size = 1;
% 
%     c = 1;

end

outs = stack;