function tiffstack2files(image_stack, kvpairs)

s = image_stack;

% first, make the destination directory the same name as the original tiff file and enter.
mkdir(s.name);
cd(s.name);


% then, save metadata to text file for easy review
mdf = fopen('metadata.txt', 'w');
for k = 1:length(kvpairs)
    myline = strrep(kvpairs{k}, ';', '');
    fprintf(mdf, '%s\n', myline);
end
fclose(mdf);

% Next, make a frames subdirectory to contain the images and enter
mkdir('frames');
cd('frames');

% How many image types are there?
nImageTypes = length(s.planes);

% for each image type...
count = 1;
for k = 1:nImageTypes
    
    mycolor = s.colors{k};
    
%     mkdir( mycolor );
%     cd( mycolor );
    
    for m = 1:s.planes(k)
        mycount_str = num2str(count, '%04u');
        outfile = ['image' mycount_str '_' mycolor '.tiff'];    
        imwrite(s.stack(:,:,count), outfile);
        count = count + 1;
    end
    
%     cd('..');
    
end

% to get back to our directory root
cd('..');

% to return to where we started
cd('..');

return;

