function tiffstack_separate_channels(image_stack, kvpairs)

s = image_stack;

metadata = rmfield(s, 'stack');

% first, make the destination directory the same name as the original tiff file and enter.
mkdir(s.name);
cd(s.name);

% then, save metadata to text file for easy review
save_metadata(kvpairs, 'metadata.txt');

% How many image types are there?
nImageTypes = length(s.planes);

% for each image type...
oldname = s.name; 
for k = 1:nImageTypes
    
    mycolor = s.colors{k};
    
    if k==1
        starting_frame = 1;
        ending_frame = s.planes(k);
    else
        starting_frame = sum(s.planes(1:k-1))+1;
        ending_frame   = sum(s.planes(1:k));
    end
        
%     fprintf('start,end: [%i, %i]\n', starting_frame, ending_frame);
    myimages = s.stack(:,:,starting_frame:ending_frame);
    
    
    outfile = [s.name '_' mycolor '.tiff'];    

    createTiffGW(outfile, myimages, [], '.');
%     createTiffGW(outfile, s.stack, metadata, '.');
end

cd('..');

return;

function save_metadata(kvpairs, metafilename)
    mdf = fopen(metafilename, 'w');
    for k = 1:length(kvpairs)
        myline = strrep(kvpairs{k}, ';', '');
        fprintf(mdf, '%s\n', myline);
    end
    fclose(mdf);
return
    
    