function [tiff_stack, kvpairs] = unpack_tiffstack(tiff_file)

    if nargin < 1 || isempty(tiff_file)
        error('No tiff-file designated.');
    end
   
   name = strrep(tiff_file, '.tif', '');
   
   kvpairs = extract_kvpairs_from_tiff(tiff_file);
   metadata = kvpairs2struct(kvpairs);
   
   tiff_info  = imfinfo(tiff_file);
   
   num_images = numel(tiff_info);
   
   for k = 1:num_images
       image_stack(:,:,k) = imread(tiff_file,k);
   end
   
   tiff_stack = metadata;
   tiff_stack.stack = image_stack;
   tiff_stack.name = name; % would be better to have the filename at the top of the struct. Use orderfields
   
   

end